// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

import net.cellcomputing.himawari.accessory.primitive.p_float;
import net.cellcomputing.himawari.accessory.primitive.p_int;

/**
 * CqMotionSepcの基底としてインターフェイスを切り出したクラス。<br>
 * 多重継承の解決策として作成。
 * 
 * @author NTT DATA Corporation
 */
public strictfp interface IqMotionSpec<T> {

	public void assignment( final CqMotionSpec<T> From );

	public void	AddTimeSlot( float time, final T Object );

	public void	ConcatTimeSlot( float time, final T Object );

	public void	ConcatAllTimeSlots( final T Object );

	public float	Time( int index );

	public int	iTimes();

	public boolean fMotionBlurred();

	public boolean GetTimeSlot( float time, p_int iIndex, p_float Fraction );

	public boolean	TimeSlotExists( float time, p_int iIndex );

	public T	GetMotionObjectInterpolated( float time );

	public T GetMotionObject( float time );

	public T GetMotionObject( int iIndex );

	public void	SetDefaultObject( final T a );

	public void	Reset();

	public void	ClearMotionObject( T A );

	public T ConcatMotionObjects( final T A, final T B );

	public T LinearInterpolateMotionObjects( float Fraction, final T A, final T B );
	
}
